Attribute VB_Name = "ModuleByteConversion"
Option Explicit

'The conversion methods here are courtesy of passel of http://www.xtremevbtalk.com/ by e-mail
'After seeing the previous method online, he suggested copying bytes directly to destination memory.
'The previous method is contained in ModuleByteConversionOld, and involved string manipulation and
'a good deal of math.

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
  Destination As Any, _
  Source As Any, _
  ByVal Length As Long _
)

Sub ConvertBytesToSingle( _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  float As Single _
) 'This sub converts four bytes to a single precision floating point value

  Dim byteArray(1 To 4) As Byte

  If FormMain.CompMode = "PC" Then
    byteArray(1) = byte1
    byteArray(2) = byte2
    byteArray(3) = byte3
    byteArray(4) = byte4
  Else
    byteArray(1) = byte4
    byteArray(2) = byte3
    byteArray(3) = byte2
    byteArray(4) = byte1
  End If
  
  CopyMemory float, byteArray(1), 4
End Sub

Sub ConvertSingleToBytes( _
  float As Single, _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte _
) 'This sub converts a value to four bytes for storage as a single precision floating point value

  Dim byteArray(1 To 4) As Byte
  
  CopyMemory byteArray(1), float, 4
  
  If FormMain.CompMode = "PC" Then
    byte1 = byteArray(1)
    byte2 = byteArray(2)
    byte3 = byteArray(3)
    byte4 = byteArray(4)
  Else
    byte4 = byteArray(1)
    byte3 = byteArray(2)
    byte2 = byteArray(3)
    byte1 = byteArray(4)
  End If
End Sub

Sub ConvertBytesToDouble( _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  byte5 As Byte, _
  byte6 As Byte, _
  byte7 As Byte, _
  byte8 As Byte, _
  float As Double _
) 'This sub converts four bytes to a single precision floating point value

  Dim byteArray(1 To 8) As Byte

  If FormMain.CompMode = "PC" Then
    byteArray(1) = byte1
    byteArray(2) = byte2
    byteArray(3) = byte3
    byteArray(4) = byte4
    byteArray(5) = byte5
    byteArray(6) = byte6
    byteArray(7) = byte7
    byteArray(8) = byte8
  Else
    byteArray(1) = byte8
    byteArray(2) = byte7
    byteArray(3) = byte6
    byteArray(4) = byte5
    byteArray(5) = byte4
    byteArray(6) = byte3
    byteArray(7) = byte2
    byteArray(8) = byte1
  End If
  
  CopyMemory float, byteArray(1), 8
End Sub

Sub ConvertDoubleToBytes( _
  float As Double, _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  byte5 As Byte, _
  byte6 As Byte, _
  byte7 As Byte, _
  byte8 As Byte _
) 'This sub converts a number to eight bytes for storage as a double precision floating point value
  
  Dim byteArray(1 To 8) As Byte
  
  CopyMemory byteArray(1), float, 8
  
  If FormMain.CompMode = "PC" Then
    byte1 = byteArray(1)
    byte2 = byteArray(2)
    byte3 = byteArray(3)
    byte4 = byteArray(4)
    byte5 = byteArray(5)
    byte6 = byteArray(6)
    byte7 = byteArray(7)
    byte8 = byteArray(8)
  Else
    byte8 = byteArray(1)
    byte7 = byteArray(2)
    byte6 = byteArray(3)
    byte5 = byteArray(4)
    byte4 = byteArray(5)
    byte3 = byteArray(6)
    byte2 = byteArray(7)
    byte1 = byteArray(8)
  End If
End Sub

Sub ConvertBytesToSingleAndStrings( _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  float As Single, _
  string1 As String, _
  string2 As String, _
  string3 As String, _
  string4 As String _
) 'This sub converts four bytes to a single precision floating point value

  Dim byteArray(1 To 4) As Byte

  If FormMain.CompMode = "PC" Then
    byteArray(1) = byte1
    byteArray(2) = byte2
    byteArray(3) = byte3
    byteArray(4) = byte4
  Else
    byteArray(1) = byte4
    byteArray(2) = byte3
    byteArray(3) = byte2
    byteArray(4) = byte1
  End If
  
  CopyMemory float, byteArray(1), 4
  
  Call ByteToBinaryString(byte1, string1)
  Call ByteToBinaryString(byte2, string2)
  Call ByteToBinaryString(byte3, string3)
  Call ByteToBinaryString(byte4, string4)
End Sub

Sub ConvertSingleToBytesAndStrings( _
  float As Single, _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  string1 As String, _
  string2 As String, _
  string3 As String, _
  string4 As String _
) 'This sub converts a value to four bytes for storage as a single precision floating point value
  
  Dim byteArray(1 To 4) As Byte
  
  CopyMemory byteArray(1), float, 4
  
  If FormMain.CompMode = "PC" Then
    byte1 = byteArray(1)
    byte2 = byteArray(2)
    byte3 = byteArray(3)
    byte4 = byteArray(4)
  Else
    byte4 = byteArray(1)
    byte3 = byteArray(2)
    byte2 = byteArray(3)
    byte1 = byteArray(4)
  End If

  Call ByteToBinaryString(byte1, string1)
  Call ByteToBinaryString(byte2, string2)
  Call ByteToBinaryString(byte3, string3)
  Call ByteToBinaryString(byte4, string4)
End Sub

Sub ByteToBinaryString( _
  byte1 As Byte, _
  BinaryString As String _
)

  Dim CombinedString As String
  Dim RunningTotal As Double
  Dim ctr As Integer
   
  RunningTotal = byte1
  BinaryString = ""
    
  For ctr = 1 To 8
    If RunningTotal >= 2 ^ (8 - ctr) Then
      BinaryString = BinaryString + "1"
      RunningTotal = RunningTotal - 2 ^ (8 - ctr)
    Else
      BinaryString = BinaryString + "0"
    End If
  Next ctr

End Sub

