Attribute VB_Name = "ModuleIOMulti"
Option Explicit

'http://www.roseindia.net/software-tutorials/detail/6707
'IO Module for multi-axis joysticks

Dim JoyNum As Long
Dim MYJOYEX As JOYINFOEX
Dim MYJOYCAPS As JOYCAPS
Dim CenterX As Long
Dim CenterY As Long
Dim JoyButtons(15) As Boolean
Dim CurrentJoyX As Long
Dim CurrentJoyY As Long
Dim CurrentJoyZ As Long
Dim CurrentJoyR As Long
Dim CurrentJoyU As Long
Dim CurrentJoyV As Long
Dim CurrentJoyButtons As Long

Private Type JOYCAPS
  wMid As Integer
  wPid As Integer
  szPname As String * 32
  wXmin As Long
  wXmax As Long
  wYmin As Long
  wYmax As Long
  wZmin As Long
  wZmax As Long
  wNumButtons As Long
  wPeriodMin As Long
  wPeriodMax As Long
  wRmin As Long
  wRmax As Long
  wUmin As Long
  wUmax As Long
  wVmin As Long
  wVmax As Long
  wCaps As Long
  wMaxAxes As Long
  wNumAxes As Long
  wMaxButtons As Long
  szRegKey As String * 32
  szOEMVxD As String * 260
End Type

Private Type JOYINFOEX
  dwSize As Long
  dwFlags As Long
  dwXpos As Long
  dwYpos As Long
  dwZpos As Long
  dwRpos As Long
  dwUpos As Long
  dwVpos As Long
  dwButtons As Long
  dwButtonNumber As Long
  dwPOV As Long
  dwReserved1 As Long
  dwReserved2 As Long
End Type



Private Declare Function joyGetPosEx Lib "winmm.dll" (ByVal uJoyID As Long, pji As JOYINFOEX) As Long
Private Declare Function joyGetDevCapsA Lib "winmm.dll" (ByVal uJoyID As Long, pjc As JOYCAPS, ByVal cjc As Long) As Long

Private Function StartJoystick(Optional ByVal JoystickNumber As Long = 0) As Boolean
  JoyNum = JoystickNumber
  If joyGetDevCapsA(JoyNum, MYJOYCAPS, 404) <> 0 Then 'Get joystick info
    StartJoystick = False
  Else
    Call joyGetPosEx(JoyNum, MYJOYEX)
    CenterX = MYJOYEX.dwXpos
    CenterY = MYJOYEX.dwYpos
    StartJoystick = True
  End If
End Function

Private Sub PollJoystick()
  Dim i As Long
  Dim t As Long
  MYJOYEX.dwSize = 64
  MYJOYEX.dwFlags = 255
  
  ' Get the joystick information
  Call joyGetPosEx(JoyNum, MYJOYEX)
  
  'This for loop was part of the example code I downloaded, but unneeded for this application
  't = MYJOYEX.dwButtons
  'For i = 15 To 0 Step -1
  '  JoyButtons(i) = False
  '  If (2 ^ i) <= t Then
  '    t = t - (2 ^ i)
  '    JoyButtons(i) = True
  '  End If
  'Next i
  
  CurrentJoyX = MYJOYEX.dwXpos
  CurrentJoyY = MYJOYEX.dwYpos
  CurrentJoyZ = MYJOYEX.dwZpos
  CurrentJoyR = MYJOYEX.dwRpos
  CurrentJoyU = MYJOYEX.dwUpos
  CurrentJoyV = MYJOYEX.dwVpos
  CurrentJoyButtons = MYJOYEX.dwButtons
End Sub

Sub PassJoyinfo()
  Dim JoystickID As Long
  Dim Joystickinfo As JOYINFOEX
  
  JoystickID = 0

  Call PollJoystick

  If False Then
    FormMain.JoyinfoTest = False
  Else
    FormMain.JoyinfoTest = True
    FormMain.JoyinfoX = CurrentJoyX
    FormMain.JoyinfoY = CurrentJoyY
    FormMain.JoyinfoZ = CurrentJoyZ
    FormMain.JoyinfoR = CurrentJoyR
    FormMain.JoyinfoU = CurrentJoyU
    FormMain.JoyinfoV = CurrentJoyV
    FormMain.JoyinfoButtons = CurrentJoyButtons
  End If
End Sub
